'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.replace = exports.push = exports.back = exports.go = undefined;

var _query = require('./query');

var go = function go(delta) {
	uni.navigateBack({ delta: delta });
};

var back = function back() {
	uni.navigateBack();
};

var replace = function replace(location, complete, fail, success) {
	var url = (0, _query.parseUrl)(location);
	uni.redirectTo({ url: url, complete: complete, fail: fail, success: success });
};

var push = function push(location, complete, fail, success) {
	var url = (0, _query.parseUrl)(location);
	var params = { url: url, complete: complete, fail: fail, success: success };

	if (location.isTab) {
		uni.switchTab(params);
		return;
	}
	if (location.reLaunch) {
		uni.reLaunch(params);
		return;
	}
	uni.navigateTo(params);
};

exports.go = go;
exports.back = back;
exports.push = push;
exports.replace = replace;